/**
* \mainpage GangOfSix (GOS) - RoboCup project
* 
* \section Introduction
* This documentation was created as an output of a team project at the Faculty of Informatics and Information Technology at Slovak Technical University in Bratislava.
* Team GOS extended the player of UVA Trilearn therefore this documentation also consists of original documentation of the team UVA Trilearn.
*/

#ifndef ARSTOOLBOX_H_
#define ARSTOOLBOX_H_

#include "Geometry.h"

class ArsToolbox
{
public:

	static int lineLineCrossPoint(double x1, double y1, double x2, double y2, 
	                double x3, double y3,double x4, double y4, double *cpx, 
	                double *cpy);
	
	static int circleCircleIntersection(double x0, double y0, double r0,
	                double x1, double y1, double r1,
	                double *xi, double *yi,
	                double *xi_prime, double *yi_prime);
	                               
	static double vectorsAngle(double v1ex, double v1ey, double v2ex, double v2ey);
	
	static double vectorNorm(double v1x, double v1y);
	
	static int circleLineIntersection(double p1x, double p1y, double p2x, 
	                double p2y, double cx, double cy, double r, double *v1x, 
	                double *v1y, double *v2x, double *v2y, bool line);
	static int circleLineIntersection(double p1x, double p1y, double p2x, 
	                double p2y, double cx, double cy, double r, double *v1x, 
	                double *v1y, double *v2x, double *v2y);
	
	static int createLineTo(double sx, double sy, double angle, double length, 
	                double *ex, double *ey);
	
	static double linePointDistance(double dX1, double dY1, double dX2, double dY2,
	                double dPX, double dPY);
	static double trim(double value, double min, double max);
	static int distancePointLine(VecPosition point, VecPosition lineStart, VecPosition lineEnd, double *distance);

	
	
	static double computeLeastInterceptTime(VecPosition b0, VecPosition v0, VecPosition r0, double vR, double tau = 2.0);
};

#endif

